#ifndef MDIARY_H
#define MDIARY_H

#include <glib.h>
#include <gtk/gtk.h>
#include <stdlib.h>

enum {
	COL_TITLE = 0,  /* Title of the entry */
	COL_DATE_TEXT,	/* Textual representation of the date (auto generated) */
	COL_TAGS_TEXT,	/* Textual representation of the tags (auto generated) */
	COL_TIMESTAMP,  /* GDateTime of the entry */
	COL_TAGLIST,    /* GList<gchar *> of the tags */
	COL_SUMMARY,	/* Summary of the entry */
	COL_TEXT,	/* Raw text from the file */
	COL_COUNT
};

void mdiary_scan_to_store(gchar *base_dir, GtkListStore *entryListStore, GtkListStore *autoCompletion);
void mdiary_add_entry_to_store(GtkListStore *entryListStore,
			       GtkListStore *autoCompletion,
			       gchar *title,
			       GDateTime *datetime,
			       GList *tags,
			       gchar *summary,
			       gchar *text);
GDateTime *mdiary_get_date_from_string_ext(gchar *string, gchar *prefix, gchar *suffix);
GDateTime *mdiary_get_date_from_string(gchar *string);
gint64 mdiary_get_time_earliest(void);
gint64 mdiary_get_time_latest(void);

#endif /* MDIARY_H */
